/*

   v1.03 Shutdown

   Marko Seppnen
   marko.seppanen@wwnet.fi

*/


address IMAGEENGINEER

Options results
signal on error

NL='0a'x


PROJECT_LIST
biglist=result

if biglist == "" then do

  ADDRESS COMMAND "run >nil: rx ie:arexx/quit"
  exit

end
else do

  GET PRIMARY
  primarypic=result

  GET ALPHA
  alphapic=result

  GET SECONDARY
  secpic=result

  images=words(biglist)


  if exists("ie:prefs/shutdown.cfg") == "1" then
    do
      call open("temp","ie:prefs/shutdown.cfg","R")
      values=readln("temp")
      parse var values ok fileformat savepath .
      call close("temp")
    end
  else
    do
      fileformat=0
      savepath="<select_temporary_directory>"
    end


  do until savedircheck==1

    'FORM "Shutdown" "Quit&Save|Quit|Cancel"',
    'CYCLE,"Fileformat","PNG|TIFF",'fileformat'',
    'DIR,"Savepath",'savepath''

    values=result
    parse var values ok fileformat savepath .
    if ok = 0 then exit
    if ok = 2 then do

      ADDRESS COMMAND "run >nil: rx ie:arexx/quit"
      exit

    end

    call open("temp","ie:prefs/shutdown.cfg","W")
    res=writeln("temp",values)
    call close("temp")



    /* SAVEPATH CHECK */

    savepath=strip(savepath,B,'"')

    if exists(savepath) ~== 1 then do
      'REQUEST "Please give an existing directory." "Sorry|Cancel"'
      if result = 0 then exit
    end
    else savedircheck=1

  end



  endpart=right(savepath,1)
  if endpart~=":" & endpart~="/" then savepath=savepath||"/"


  if fileformat == "0" then filetype="PNG (PiNG)"
  if fileformat == "1" then filetype="TIFF V5.0"




  /* IS THERE EARLIER SHUTDOWN SAVING? */

  if exists("ie:prefs/shutdownimagelist.cfg") == 1 then do

    'REQUEST "There seems to be earlier'||NL||'Shutdown saving on disk." "Remove all|Leave images|Cancel|Quit"'
    ok=result

    if ok = 1 then do

      call open("temp","ie:prefs/shutdownimagelist.cfg","R")

      do forever

        fullline=readln("temp")
        parse var fullline iname .
        if word(fullline,1) ~== "PRIMARY" then ADDRESS COMMAND "c:delete "savepath||iname" QUIET"
        else leave

      end

      call close("temp")
      ADDRESS COMMAND "c:delete ie:prefs/shutdownimagelist.cfg QUIET"

    end

    if ok = 3 then exit
    if ok = 0 then do

      ADDRESS COMMAND "run >nil: rx ie:arexx/quit"
      exit

    end

  end



  call open("temp","ie:prefs/shutdownimagelist.cfg","W")



  /* THE LOOP */

  do until images = 0

    imagename=word(biglist,images)
    images=images-1

    if imagename ~== "" then do

      PROJECT_INFO imagename TYPE
      pictype=result

      PROJECT_INFO imagename ZOOM
      piczoom=result

      PROJECT_INFO imagename OFFSETS
      parse var result picx picy .

      PROJECT_INFO imagename WINDOW
      parse var result posx posy winwidth winheight .

      fullline=imagename||" "||pictype||" "||piczoom||" "||picx||" "||picy||" "||posx||" "||posy||" "||winwidth||" "||winheight
      res=writeln("temp",fullline)

      fullpath=savepath||imagename
      SAVE_DATA imagename '"'fullpath'"' '"'filetype'"'

      CLOSE imagename

    end

  end

end



res=writeln("temp","PRIMARY "||primarypic)
res=writeln("temp","ALPHA "||alphapic)
res=writeln("temp","SECONDARY "||secpic)

call close("temp")


ADDRESS COMMAND "run >nil: rx ie:arexx/quit"
exit


exit


/*******************************************************************/
/* This is where control goes when an error code is returned by IE */
/* It puts up a message saying what happened and on which line     */
/*******************************************************************/
error:
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
	exit
end
else do
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
	exit
end
