/*

   v1.05 Close All

   Marko Seppnen
   marko.seppanen@wwnet.fi

*/


address IMAGEENGINEER

Options results
signal on error			/* Setup a place for errors to go */

checkbit=0

GET ALPHA
apic=result
GET PRIMARY
ppic=result
if apic=ppic then checkbit=1


PROJECT_LIST
list=result

if list="" then exit

kpl=words(list)

do i=1 to kpl

  pic=subword(list,i,1)
  if pic=apic then do
    if checkbit~="1" then CLOSE pic
  end
  else do
    CLOSE pic
  end

end


exit

/*******************************************************************/
/* This is where control goes when an error code is returned by IE */
/* It puts up a message saying what happened and on which line     */
/*******************************************************************/
error:
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
	exit
end
else do
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
	exit
end
