/*

   v1.00 DeInterlace (for Image Engineer)

   Marko Seppnen
   marko.seppanen@wwnet.fi

*/


address IMAGEENGINEER

Options results
signal on error			/* Setup a place for errors to go */


if arg()=0 then exit
x=arg(1)
parse var x pic .


PROJECT_INFO pic WIDTH
picwidth=result
PROJECT_INFO pic HEIGHT
picheight=result
PROJECT_INFO pic ZOOM
piczoom=result



if exists("ie:alpha/lacelines.alpha") == "0" then do
  'REQUEST "Please download VE-Extras.lha" "Ok"'
  exit
end


OPEN "ie:alpha/lacelines.alpha" COLOUR
lines=result

PROJECT_SET lines ZOOM piczoom

RESIZE lines picwidth picheight+1 TILE
lacelines=result
CLOSE lines




MARK pic PRIMARY
MARK lacelines SECONDARY
COMPOSITE 0 0 MIN
lacepic=result

SCALE lacepic picwidth trunc(picheight/2) FAST
newpic=result

CLOSE lacepic



MARK pic PRIMARY
MARK lacelines SECONDARY
COMPOSITE 0 1 MIN
lacesec=result

SCALE lacesec picwidth trunc(picheight/2) FAST
newsec=result


CLOSE lacesec
CLOSE lacelines



exit

/*******************************************************************/
/* This is where control goes when an error code is returned by IE */
/* It puts up a message saying what happened and on which line     */
/*******************************************************************/
error:
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
	exit
end
else do
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
	exit
end
