/**************************************************/
/* Image Engineer script                          */
/* by Simon Edwards                               */
/* 15/3/96                                        */
/* Filters pepper (0 value pixels) from an image. */
/**************************************************/

Options results
signal on error			/* Setup a place for errors to go */

if arg()==0 then exit

THRESHOLD arg(1) 1
pepperimage=result

MEDIAN arg(1) 3 3
filtered=result

MARK arg(1) PRIMARY
MARK filtered SECONDARY
MARK pepperimage ALPHA
COMPOSITE 0 0 ALPHA

CLOSE pepperimage
CLOSE filtered

exit

/*******************************************************************/
/* This is where control goes when an error code is returned by IE */
/* It puts up a message saying what happened and on which line     */
/*******************************************************************/
error:
if RC=5 then do			/* Did the user just cancel us? */
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "'||RESULT||'"'
	exit
end
else do
	IE_TO_FRONT
	LAST_ERROR
	'REQUEST "Error detected!!!'||D2C(10)||'Image Engineer error message is as follows'||D2C(10)||result||D2C(10)||'Script failed on line '||SIGL||'"' 'Doh!'
	exit
end
